from base64 import b64encode, b64decode
from hashlib import sha1

def encrypt(text):
    encoded = b64encode(text)
    encoded_no_padding = encoded.rstrip('=')
    return ''.join(char for char in reversed(encoded_no_padding))

def decrypt(encrypted_text):
    encoded_no_padding = ''.join(char for char in reversed(encrypted_text))
    encoded = encoded_no_padding + '=' * (len(encoded_no_padding) % 4)
    return b64decode(encoded)

def is_encrypted_password(password):
    if not password or len(password) <= 40:
        return False
    return sha1(password[20:-20]).hexdigest() == (password[:20] + password[-20:])

def encrypt_password(password):
    if is_encrypted_password(password):
        return password
    encrypted = encrypt(password)
    digest = sha1(encrypted).hexdigest()
    return digest[:20] + encrypted + digest[20:]

def decrypt_password(password):
    if not is_encrypted_password(password):
        return password
    return decrypt(password[20:-20])
