from numbers import Integral

from .values import StorageCapacityRenderer

def render_capacity(size):
    size = size or 0
    if not isinstance(size, Integral):
        return size
    return StorageCapacityRenderer().render(size, "-")

CANONICAL_CASE = {
	'iscsi'  : 'iSCSI',
	'bbu'    : 'BBU',
	'ssd'    : 'SSD',
	'ssl'    : 'SSL',
	'snmp'   : 'SNMP',
	'id'     : 'ID',
	'wwnn'   : 'WWNN',
	'raid'   : 'RAID',
	'ip'     : 'IP',
	'dns'    : 'DNS',
	'ntp'    : 'NTP',
	'fs'     : 'FS',
	'nfs'    : 'NFS',
	'ldaps'  : 'LDAPS',
	'basedn' : 'Base DN',
}

CANONICAL_CASE_RE = '|'.join(CANONICAL_CASE.keys())
